/**
 * @module       jQuery Form Plugin
 * @version      3.51
 * @author       M. Alsup
 * @see          http://malsup.com/jquery/form/
 * @license      MIT and GPL licenses
 */
!function (e) {
    "use strict";
    "function" == typeof define && define.amd ? define(["../jquery"], e) : e("undefined" != typeof jQuery ? jQuery : window.Zepto)
}(function (e) {
    "use strict";
    function t(t) {
        var r = t.data;
        t.isDefaultPrevented() || (t.preventDefault(), e(t.target).ajaxSubmit(r))
    }

    function r(t) {
        var r = t.target, a = e(r);
        if (!a.is("[type=submit],[type=image]")) {
            var n = a.closest("[type=submit]");
            if (0 === n.length)return;
            r = n[0]
        }
        var i = this;
        if (i.clk = r, "image" == r.type)if (void 0 !== t.offsetX)i.clk_x = t.offsetX, i.clk_y = t.offsetY; else if ("function" == typeof e.fn.offset) {
            var o = a.offset();
            i.clk_x = t.pageX - o.left, i.clk_y = t.pageY - o.top
        } else i.clk_x = t.pageX - r.offsetLeft, i.clk_y = t.pageY - r.offsetTop;
        setTimeout(function () {
            i.clk = i.clk_x = i.clk_y = null
        }, 100)
    }

    function a() {
        if (e.fn.ajaxSubmit.debug) {
            var t = "[jquery.form] " + Array.prototype.join.call(arguments, "");
            window.console && window.console.log ? window.console.log(t) : window.opera && window.opera.postError && window.opera.postError(t)
        }
    }

    var n = {};
    n.fileapi = void 0 !== e("<input type='file'/>").get(0).files, n.formdata = void 0 !== window.FormData;
    var i = !!e.fn.prop;
    e.fn.attr2 = function () {
        if (!i)return this.attr.apply(this, arguments);
        var e = this.prop.apply(this, arguments);
        return e && e.jquery || "string" == typeof e ? e : this.attr.apply(this, arguments)
    }, e.fn.ajaxSubmit = function (t) {
        function r(r) {
            var a, n, i = e.param(r, t.traditional).split("&"), o = i.length, s = [];
            for (a = 0; o > a; a++)i[a] = i[a].replace(/\+/g, " "), n = i[a].split("="), s.push([decodeURIComponent(n[0]), decodeURIComponent(n[1])]);
            return s
        }

        function o(a) {
            for (var n = new FormData, i = 0; i < a.length; i++)n.append(a[i].name, a[i].value);
            if (t.extraData) {
                var o = r(t.extraData);
                for (i = 0; i < o.length; i++)o[i] && n.append(o[i][0], o[i][1])
            }
            t.data = null;
            var s = e.extend(!0, {}, e.ajaxSettings, t, {
                contentType: !1,
                processData: !1,
                cache: !1,
                type: u || "POST"
            });
            t.uploadProgress && (s.xhr = function () {
                var r = e.ajaxSettings.xhr();
                return r.upload && r.upload.addEventListener("progress", function (e) {
                    var r = 0, a = e.loaded || e.position, n = e.total;
                    e.lengthComputable && (r = Math.ceil(a / n * 100)), t.uploadProgress(e, a, n, r)
                }, !1), r
            }), s.data = null;
            var c = s.beforeSend;
            return s.beforeSend = function (e, r) {
                r.data = t.formData ? t.formData : n, c && c.call(this, e, r)
            }, e.ajax(s)
        }

        function s(r) {
            function n(e) {
                var t = null;
                try {
                    e.contentWindow && (t = e.contentWindow.document)
                } catch (r) {
                    a("cannot get iframe.contentWindow document: " + r)
                }
                if (t)return t;
                try {
                    t = e.contentDocument ? e.contentDocument : e.document
                } catch (r) {
                    a("cannot get iframe.contentDocument: " + r), t = e.document
                }
                return t
            }

            function o() {
                function t() {
                    try {
                        var e = n(g).readyState;
                        a("state = " + e), e && "uninitialized" == e.toLowerCase() && setTimeout(t, 50)
                    } catch (r) {
                        a("Server abort: ", r, " (", r.name, ")"), s(k), j && clearTimeout(j), j = void 0
                    }
                }

                var r = f.attr2("target"), i = f.attr2("action"), o = "multipart/form-data", c = f.attr("enctype") || f.attr("encoding") || o;
                w.setAttribute("target", p), (!u || /post/i.test(u)) && w.setAttribute("method", "POST"), i != m.url && w.setAttribute("action", m.url), m.skipEncodingOverride || u && !/post/i.test(u) || f.attr({
                    encoding: "multipart/form-data",
                    enctype: "multipart/form-data"
                }), m.timeout && (j = setTimeout(function () {
                    T = !0, s(D)
                }, m.timeout));
                var l = [];
                try {
                    if (m.extraData)for (var d in m.extraData)m.extraData.hasOwnProperty(d) && l.push(e.isPlainObject(m.extraData[d]) && m.extraData[d].hasOwnProperty("name") && m.extraData[d].hasOwnProperty("value") ? e('<input type="hidden" name="' + m.extraData[d].name + '">').val(m.extraData[d].value).appendTo(w)[0] : e('<input type="hidden" name="' + d + '">').val(m.extraData[d]).appendTo(w)[0]);
                    m.iframeTarget || v.appendTo("body"), g.attachEvent ? g.attachEvent("onload", s) : g.addEventListener("load", s, !1), setTimeout(t, 15);
                    try {
                        w.submit()
                    } catch (h) {
                        var x = document.createElement("form").submit;
                        x.apply(w)
                    }
                } finally {
                    w.setAttribute("action", i), w.setAttribute("enctype", c), r ? w.setAttribute("target", r) : f.removeAttr("target"), e(l).remove()
                }
            }

            function s(t) {
                if (!x.aborted && !F) {
                    if (M = n(g), M || (a("cannot access response document"), t = k), t === D && x)return x.abort("timeout"), void S.reject(x, "timeout");
                    if (t == k && x)return x.abort("server abort"), void S.reject(x, "error", "server abort");
                    if (M && M.location.href != m.iframeSrc || T) {
                        g.detachEvent ? g.detachEvent("onload", s) : g.removeEventListener("load", s, !1);
                        var r, i = "success";
                        try {
                            if (T)throw"timeout";
                            var o = "xml" == m.dataType || M.XMLDocument || e.isXMLDoc(M);
                            if (a("isXml=" + o), !o && window.opera && (null === M.body || !M.body.innerHTML) && --O)return a("requeing onLoad callback, DOM not available"), void setTimeout(s, 250);
                            var u = M.body ? M.body : M.documentElement;
                            x.responseText = u ? u.innerHTML : null, x.responseXML = M.XMLDocument ? M.XMLDocument : M, o && (m.dataType = "xml"), x.getResponseHeader = function (e) {
                                var t = {"content-type": m.dataType};
                                return t[e.toLowerCase()]
                            }, u && (x.status = Number(u.getAttribute("status")) || x.status, x.statusText = u.getAttribute("statusText") || x.statusText);
                            var c = (m.dataType || "").toLowerCase(), l = /(json|script|text)/.test(c);
                            if (l || m.textarea) {
                                var f = M.getElementsByTagName("textarea")[0];
                                if (f)x.responseText = f.value, x.status = Number(f.getAttribute("status")) || x.status, x.statusText = f.getAttribute("statusText") || x.statusText; else if (l) {
                                    var p = M.getElementsByTagName("pre")[0], h = M.getElementsByTagName("body")[0];
                                    p ? x.responseText = p.textContent ? p.textContent : p.innerText : h && (x.responseText = h.textContent ? h.textContent : h.innerText)
                                }
                            } else"xml" == c && !x.responseXML && x.responseText && (x.responseXML = X(x.responseText));
                            try {
                                E = _(x, c, m)
                            } catch (y) {
                                i = "parsererror", x.error = r = y || i
                            }
                        } catch (y) {
                            a("error caught: ", y), i = "error", x.error = r = y || i
                        }
                        x.aborted && (a("upload aborted"), i = null), x.status && (i = x.status >= 200 && x.status < 300 || 304 === x.status ? "success" : "error"), "success" === i ? (m.success && m.success.call(m.context, E, "success", x), S.resolve(x.responseText, "success", x), d && e.event.trigger("ajaxSuccess", [x, m])) : i && (void 0 === r && (r = x.statusText), m.error && m.error.call(m.context, x, i, r), S.reject(x, "error", r), d && e.event.trigger("ajaxError", [x, m, r])), d && e.event.trigger("ajaxComplete", [x, m]), d && !--e.active && e.event.trigger("ajaxStop"), m.complete && m.complete.call(m.context, x, i), F = !0, m.timeout && clearTimeout(j), setTimeout(function () {
                            m.iframeTarget ? v.attr("src", m.iframeSrc) : v.remove(), x.responseXML = null
                        }, 100)
                    }
                }
            }

            var c, l, m, d, p, v, g, x, y, b, T, j, w = f[0], S = e.Deferred();
            if (S.abort = function (e) {
                    x.abort(e)
                }, r)for (l = 0; l < h.length; l++)c = e(h[l]), i ? c.prop("disabled", !1) : c.removeAttr("disabled");
            if (m = e.extend(!0, {}, e.ajaxSettings, t), m.context = m.context || m, p = "jqFormIO" + (new Date).getTime(), m.iframeTarget ? (v = e(m.iframeTarget), b = v.attr2("name"), b ? p = b : v.attr2("name", p)) : (v = e('<iframe name="' + p + '" src="' + m.iframeSrc + '" />'), v.css({
                    position: "absolute",
                    top: "-1000px",
                    left: "-1000px"
                })), g = v[0], x = {
                    aborted: 0,
                    responseText: null,
                    responseXML: null,
                    status: 0,
                    statusText: "n/a",
                    getAllResponseHeaders: function () {
                    },
                    getResponseHeader: function () {
                    },
                    setRequestHeader: function () {
                    },
                    abort: function (t) {
                        var r = "timeout" === t ? "timeout" : "aborted";
                        a("aborting upload... " + r), this.aborted = 1;
                        try {
                            g.contentWindow.document.execCommand && g.contentWindow.document.execCommand("Stop")
                        } catch (n) {
                        }
                        v.attr("src", m.iframeSrc), x.error = r, m.error && m.error.call(m.context, x, r, t), d && e.event.trigger("ajaxError", [x, m, r]), m.complete && m.complete.call(m.context, x, r)
                    }
                }, d = m.global, d && 0 === e.active++ && e.event.trigger("ajaxStart"), d && e.event.trigger("ajaxSend", [x, m]), m.beforeSend && m.beforeSend.call(m.context, x, m) === !1)return m.global && e.active--, S.reject(), S;
            if (x.aborted)return S.reject(), S;
            y = w.clk, y && (b = y.name, b && !y.disabled && (m.extraData = m.extraData || {}, m.extraData[b] = y.value, "image" == y.type && (m.extraData[b + ".x"] = w.clk_x, m.extraData[b + ".y"] = w.clk_y)));
            var D = 1, k = 2, A = e("meta[name=csrf-token]").attr("content"), L = e("meta[name=csrf-param]").attr("content");
            L && A && (m.extraData = m.extraData || {}, m.extraData[L] = A), m.forceSync ? o() : setTimeout(o, 10);
            var E, M, F, O = 50, X = e.parseXML || function (e, t) {
                    return window.ActiveXObject ? (t = new ActiveXObject("Microsoft.XMLDOM"), t.async = "false", t.loadXML(e)) : t = (new DOMParser).parseFromString(e, "text/xml"), t && t.documentElement && "parsererror" != t.documentElement.nodeName ? t : null
                }, C = e.parseJSON || function (e) {
                    return window.eval("(" + e + ")")
                }, _ = function (t, r, a) {
                var n = t.getResponseHeader("content-type") || "", i = "xml" === r || !r && n.indexOf("xml") >= 0, o = i ? t.responseXML : t.responseText;
                return i && "parsererror" === o.documentElement.nodeName && e.error && e.error("parsererror"), a && a.dataFilter && (o = a.dataFilter(o, r)), "string" == typeof o && ("json" === r || !r && n.indexOf("json") >= 0 ? o = C(o) : ("script" === r || !r && n.indexOf("javascript") >= 0) && e.globalEval(o)), o
            };
            return S
        }

        if (!this.length)return a("ajaxSubmit: skipping submit process - no element selected"), this;
        var u, c, l, f = this;
        "function" == typeof t ? t = {success: t} : void 0 === t && (t = {}), u = t.type || this.attr2("method"), c = t.url || this.attr2("action"), l = "string" == typeof c ? e.trim(c) : "", l = l || window.location.href || "", l && (l = (l.match(/^([^#]+)/) || [])[1]), t = e.extend(!0, {
            url: l,
            success: e.ajaxSettings.success,
            type: u || e.ajaxSettings.type,
            iframeSrc: /^https/i.test(window.location.href || "") ? "javascript:false" : "about:blank"
        }, t);
        var m = {};
        if (this.trigger("form-pre-serialize", [this, t, m]), m.veto)return a("ajaxSubmit: submit vetoed via form-pre-serialize trigger"), this;
        if (t.beforeSerialize && t.beforeSerialize(this, t) === !1)return a("ajaxSubmit: submit aborted via beforeSerialize callback"), this;
        var d = t.traditional;
        void 0 === d && (d = e.ajaxSettings.traditional);
        var p, h = [], v = this.formToArray(t.semantic, h);
        if (t.data && (t.extraData = t.data, p = e.param(t.data, d)), t.beforeSubmit && t.beforeSubmit(v, this, t) === !1)return a("ajaxSubmit: submit aborted via beforeSubmit callback"), this;
        if (this.trigger("form-submit-validate", [v, this, t, m]), m.veto)return a("ajaxSubmit: submit vetoed via form-submit-validate trigger"), this;
        var g = e.param(v, d);
        p && (g = g ? g + "&" + p : p), "GET" == t.type.toUpperCase() ? (t.url += (t.url.indexOf("?") >= 0 ? "&" : "?") + g, t.data = null) : t.data = g;
        var x = [];
        if (t.resetForm && x.push(function () {
                f.resetForm()
            }), t.clearForm && x.push(function () {
                f.clearForm(t.includeHidden)
            }), !t.dataType && t.target) {
            var y = t.success || function () {
                };
            x.push(function (r) {
                var a = t.replaceTarget ? "replaceWith" : "html";
                e(t.target)[a](r).each(y, arguments)
            })
        } else t.success && x.push(t.success);
        if (t.success = function (e, r, a) {
                for (var n = t.context || this, i = 0, o = x.length; o > i; i++)x[i].apply(n, [e, r, a || f, f])
            }, t.error) {
            var b = t.error;
            t.error = function (e, r, a) {
                var n = t.context || this;
                b.apply(n, [e, r, a, f])
            }
        }
        if (t.complete) {
            var T = t.complete;
            t.complete = function (e, r) {
                var a = t.context || this;
                T.apply(a, [e, r, f])
            }
        }
        var j = e("input[type=file]:enabled", this).filter(function () {
            return "" !== e(this).val()
        }), w = j.length > 0, S = "multipart/form-data", D = f.attr("enctype") == S || f.attr("encoding") == S, k = n.fileapi && n.formdata;
        a("fileAPI :" + k);
        var A, L = (w || D) && !k;
        t.iframe !== !1 && (t.iframe || L) ? t.closeKeepAlive ? e.get(t.closeKeepAlive, function () {
            A = s(v)
        }) : A = s(v) : A = (w || D) && k ? o(v) : e.ajax(t), f.removeData("jqxhr").data("jqxhr", A);
        for (var E = 0; E < h.length; E++)h[E] = null;
        return this.trigger("form-submit-notify", [this, t]), this
    }, e.fn.ajaxForm = function (n) {
        if (n = n || {}, n.delegation = n.delegation && e.isFunction(e.fn.on), !n.delegation && 0 === this.length) {
            var i = {s: this.selector, c: this.context};
            return !e.isReady && i.s ? (a("DOM not ready, queuing ajaxForm"), e(function () {
                e(i.s, i.c).ajaxForm(n)
            }), this) : (a("terminating; zero elements found by selector" + (e.isReady ? "" : " (DOM not ready)")), this)
        }
        return n.delegation ? (e(document).off("submit.form-plugin", this.selector, t).off("click.form-plugin", this.selector, r).on("submit.form-plugin", this.selector, n, t).on("click.form-plugin", this.selector, n, r), this) : this.ajaxFormUnbind().bind("submit.form-plugin", n, t).bind("click.form-plugin", n, r)
    }, e.fn.ajaxFormUnbind = function () {
        return this.unbind("submit.form-plugin click.form-plugin")
    }, e.fn.formToArray = function (t, r) {
        var a = [];
        if (0 === this.length)return a;
        var i, o = this[0], s = this.attr("id"), u = t ? o.getElementsByTagName("*") : o.elements;
        if (u && !/MSIE [678]/.test(navigator.userAgent) && (u = e(u).get()), s && (i = e(':input[form="' + s + '"]').get(), i.length && (u = (u || []).concat(i))), !u || !u.length)return a;
        var c, l, f, m, d, p, h;
        for (c = 0, p = u.length; p > c; c++)if (d = u[c], f = d.name, f && !d.disabled)if (t && o.clk && "image" == d.type)o.clk == d && (a.push({
            name: f,
            value: e(d).val(),
            type: d.type
        }), a.push({name: f + ".x", value: o.clk_x}, {
            name: f + ".y",
            value: o.clk_y
        })); else if (m = e.fieldValue(d, !0), m && m.constructor == Array)for (r && r.push(d), l = 0, h = m.length; h > l; l++)a.push({
            name: f,
            value: m[l]
        }); else if (n.fileapi && "file" == d.type) {
            r && r.push(d);
            var v = d.files;
            if (v.length)for (l = 0; l < v.length; l++)a.push({
                name: f,
                value: v[l],
                type: d.type
            }); else a.push({name: f, value: "", type: d.type})
        } else null !== m && "undefined" != typeof m && (r && r.push(d), a.push({
            name: f,
            value: m,
            type: d.type,
            required: d.required
        }));
        if (!t && o.clk) {
            var g = e(o.clk), x = g[0];
            f = x.name, f && !x.disabled && "image" == x.type && (a.push({
                name: f,
                value: g.val()
            }), a.push({name: f + ".x", value: o.clk_x}, {name: f + ".y", value: o.clk_y}))
        }
        return a
    }, e.fn.formSerialize = function (t) {
        return e.param(this.formToArray(t))
    }, e.fn.fieldSerialize = function (t) {
        var r = [];
        return this.each(function () {
            var a = this.name;
            if (a) {
                var n = e.fieldValue(this, t);
                if (n && n.constructor == Array)for (var i = 0, o = n.length; o > i; i++)r.push({
                    name: a,
                    value: n[i]
                }); else null !== n && "undefined" != typeof n && r.push({name: this.name, value: n})
            }
        }), e.param(r)
    }, e.fn.fieldValue = function (t) {
        for (var r = [], a = 0, n = this.length; n > a; a++) {
            var i = this[a], o = e.fieldValue(i, t);
            null === o || "undefined" == typeof o || o.constructor == Array && !o.length || (o.constructor == Array ? e.merge(r, o) : r.push(o))
        }
        return r
    }, e.fieldValue = function (t, r) {
        var a = t.name, n = t.type, i = t.tagName.toLowerCase();
        if (void 0 === r && (r = !0), r && (!a || t.disabled || "reset" == n || "button" == n || ("checkbox" == n || "radio" == n) && !t.checked || ("submit" == n || "image" == n) && t.form && t.form.clk != t || "select" == i && -1 == t.selectedIndex))return null;
        if ("select" == i) {
            var o = t.selectedIndex;
            if (0 > o)return null;
            for (var s = [], u = t.options, c = "select-one" == n, l = c ? o + 1 : u.length, f = c ? o : 0; l > f; f++) {
                var m = u[f];
                if (m.selected) {
                    var d = m.value;
                    if (d || (d = m.attributes && m.attributes.value && !m.attributes.value.specified ? m.text : m.value), c)return d;
                    s.push(d)
                }
            }
            return s
        }
        return e(t).val()
    }, e.fn.clearForm = function (t) {
        return this.each(function () {
            e("input,select,textarea", this).clearFields(t)
        })
    }, e.fn.clearFields = e.fn.clearInputs = function (t) {
        var r = /^(?:color|date|datetime|email|month|number|password|range|search|tel|text|time|url|week)$/i;
        return this.each(function () {
            var a = this.type, n = this.tagName.toLowerCase();
            r.test(a) || "textarea" == n ? this.value = "" : "checkbox" == a || "radio" == a ? this.checked = !1 : "select" == n ? this.selectedIndex = -1 : "file" == a ? /MSIE/.test(navigator.userAgent) ? e(this).replaceWith(e(this).clone(!0)) : e(this).val("") : t && (t === !0 && /hidden/.test(a) || "string" == typeof t && e(this).is(t)) && (this.value = "")
        })
    }, e.fn.resetForm = function () {
        return this.each(function () {
            ("function" == typeof this.reset || "object" == typeof this.reset && !this.reset.nodeType) && this.reset()
        })
    }, e.fn.enable = function (e) {
        return void 0 === e && (e = !0), this.each(function () {
            this.disabled = !e
        })
    }, e.fn.selected = function (t) {
        return void 0 === t && (t = !0), this.each(function () {
            var r = this.type;
            if ("checkbox" == r || "radio" == r)this.checked = t; else if ("option" == this.tagName.toLowerCase()) {
                var a = e(this).parent("select");
                t && a[0] && "select-one" == a[0].type && a.find("option").selected(!1), this.selected = t
            }
        })
    }, e.fn.ajaxSubmit.debug = !1
});

/**
* @module       RD Mail Form
* @version      1.1.1
* @author       Evgeniy Gusarov
* @see          https://ua.linkedin.com/pub/evgeniy-gusarov/8a/a40/54a
    */
!function (e) {
    function t(o, s, n) {
        i = e.extend(!0, {}, i, n), this.options = e.extend(!0, {}, t.Defaults, s), this.$element = e(o), this._plugins = {}, this._handlers = {
            "mf.success mf.fail": e.proxy(this.update, this),
            "mf.process": e.proxy(this.process, this),
            reset: e.proxy(this.reset, this)
        }, e.each(t.Plugins, e.proxy(function (e, t) {
            this._plugins[e[0].toLowerCase() + e.slice(1)] = new t(this)
        }, this)), this.initialize()
    }

    var i;
    i = {
        MF000: "Sent",
        MF001: "Recipients are not set!",
        MF002: "Form will not work locally!",
        MF003: "Please, define email field in your form!",
        MF004: "Please, define type of your form!",
        MF254: "Something went wrong with PHPMailer!",
        MF255: "Aw, snap! Something went wrong."
    }, t.Defaults = {baseClass: "rd-mailform"}, t.Plugins = {}, t.prototype.initialize = function () {
        this.$element.trigger("mf.initialize"), this.$element.addClass(this.options.baseClass).trigger("reset"), this.create(), this.watch(), this.$element.trigger("mf.initialized")
    }, t.prototype.create = function () {
    }, t.prototype.watch = function () {
        var e = this;
        e.$element.ajaxForm({
            beforeSubmit: function () {
                e.$element.trigger("mf.process")
            }, error: function (t) {
                e.$element.trigger("mf.fail", {code: t, message: i[t]})
            }, success: function (t) {
                console.log(t), "MF000" == t ? e.$element.trigger("mf.success", {
                    code: t,
                    message: i[t]
                }) : (t = 5 == t.length ? t : "MF255", e.$element.trigger("mf.fail", {code: t, message: i[t]}))
            }
        }).on(this._handlers)
    }, t.prototype.process = function () {
        this.$element.addClass("process")
    }, t.prototype.update = function (t, i) {
        this.$element.removeClass("process"), this.$element.addClass("MF000" === i.code ? "success" : "fail"), setTimeout(e.proxy(function () {
            this.$element.trigger("reset")
        }, this), 3e3)
    }, t.prototype.reset = function () {
        this.$element.removeClass("success"), this.$element.removeClass("fail"), this.$element.trigger("mf.reset")
    }, e.fn.rdMailForm = function (i, o) {
        return this.each(function () {
            e(this).data("rdMailForm") || e(this).data("rdMailForm", new t(this, i, o))
        })
    }, e.fn.rdMailForm.Constructor = t
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.Validator = function (i) {
        this._core = i, this._handlers = {
            "mfValidator.validate": this.validate,
            "mfValidator.error": this.error,
            "mfValidator.valid": this.valid,
            "mfValidator.reset": this.reset,
            "mfValidator.click": e.noop()
        }, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    t.Defaults = {
        validator: {
            applyTo: "[data-constraints]",
            "class": "mfValidation",
            constraints: {
                "@LettersOnly": {
                    rule: "^([a-zA-Zа-яА-ЯіїёІЇЁєЄҐґ\\s]{0,})$",
                    message: "Please use letters only!"
                },
                "@NumbersOnly": {rule: "^-?\\d*\\.?\\d*$", message: "Please use numbers only!"},
                "@NotEmpty": {rule: "([^\\s])", message: "Field should not be empty!"},
                "@Email": {
                    rule: "^(([\\w-]+(?:\\.[\\w-]+)*)@((?:[\\w-]+\\.)*\\w[\\w-]{0,66})\\.([a-z]{2,6}(?:\\.[a-z]{2})?)){0,}$",
                    message: "Enter valid e-mail address!"
                },
                "@Phone": {
                    rule: "^(\\+?\\d{0,3}\\s*\\(?\\d{1,3}\\)?\\s*\\d{3}\\s*\\d{4}){0,}$",
                    message: "Enter valid phone number!"
                },
                "@Date": {
                    rule: function (e) {
                        return navigator.userAgent.match(/(iPod|iPhone|iPad)/) ? !0 : new RegExp("^($)|(((0[13578]|10|12)(-|\\/)((0[1-9])|([12])([0-9])|(3[01]?))(-|\\/)((19)([2-9])(\\d{1})|(20)([01])(\\d{1})|([8901])(\\d{1}))|(0?[2469]|11)(-|/)(([1-9])|(0[1-9])|([12])([0-9]?)|(3[0]?))(-|/)((19)([2-9])(\\d{1})|(20)([01])(\\d{1})|([8901])(\\d{1}))))$").test(e.val())
                    }, message: "Use MM/DD/YYYY format!"
                },
                "@SelectRequired": {
                    rule: function (e) {
                        return 0 !== e.find("option:selected").index()
                    }, message: "Please choose an option!"
                }
            }
        }
    }, t.prototype.initialize = function () {
        this._core.$element.trigger("mfValidator.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfValidator.initialized")
    }, t.prototype.create = function () {
        var t = this;
        this._core.$element.find(this._core.options.validator.applyTo).each(function () {
            e(this).parent().append(e("<span/>", {"class": t._core.options.validator["class"]}))
        })
    }, t.prototype.watch = function () {
        var t = this;
        this._core.$element.find(this._core.options.validator.applyTo).on("keyup", function () {
            (e(this).is("input") || e(this).is("textarea")) && e(this).parent().find(".mfValidation").hasClass("error") && e(this).parent().trigger("mfValidator.validate", {options: t._core.options.validator})
        }).on("blur", function () {
            (e(this).is("input") || e(this).is("textarea")) && e(this).parent().trigger("mfValidator.validate", {options: t._core.options.validator})
        }).on("change", function () {
            e(this).is("select") && e(this).parent().trigger("mfValidator.validate", {options: t._core.options.validator})
        }).parent().on(this._handlers).find("." + this._core.options.validator["class"]).on("click", function () {
            e(this).removeClass("error").removeClass("show").addClass("hide").parent().trigger("mfValidator.click").find(t._core.options.validator.applyTo).focus()
        }), this._core.$element.on("submit", e.proxy(function (i) {
            return this._core.$element.find(this._core.options.validator.applyTo).each(function () {
                e(this).parent().trigger("mfValidator.validate", {options: t._core.options.validator})
            }), this._core.$element.find(".error").length ? (i.preventDefault(), !1) : void 0
        }, this)).on("mf.reset", e.proxy(function () {
            this._core.$element.find(this._core.options.validator.applyTo).each(function () {
                e(this).parent().trigger("mfValidator.reset", {options: t._core.options.validator})
            })
        }, this))
    }, t.prototype.validate = function (t, i) {
        var o, s = [], n = [], a = e(this), r = a.find(i.options.applyTo), l = r.data("constraints").match(/\@\w+/g), c = r.val();
        for (var p in l)if (i.options.constraints[l[p]]) {
            switch (typeof i.options.constraints[l[p]].rule) {
                case"function":
                    i.options.constraints[l[p]].rule(r) ? a.find(".mfValidation") && a.find(".mfValidation").attr("data-index") === p && (o = !0, a.find(".mfValidation").attr("data-index", -1)) : (s.push(i.options.constraints[l[p]].message), n.push(p), o = !0);
                    break;
                default:
                    new RegExp(i.options.constraints[l[p]].rule).test(c) ? a.find(".mfValidation").attr("data-index") && a.find(".mfValidation").attr("data-index") == p && (o = !0, a.find(".mfValidation").attr("data-index", -1)) : (s.push(i.options.constraints[l[p]].message), n.push(p), o = !0)
            }
            if (o)break
        }
        s.length ? e(this).trigger("mfValidator.error", {
            options: i.options,
            errors: s,
            indexes: n
        }) : e(this).trigger("mfValidator.valid", {options: i.options})
    }, t.prototype.error = function (t, i) {
        e(this).find("." + i.options["class"]).removeClass("valid").removeClass("hide").addClass("show").addClass("error").attr("data-index", i.indexes[0]).text(i.errors)
    }, t.prototype.valid = function (t, i) {
        var o = e(this).find("." + i.options["class"]);
        o.hasClass("error") && o.removeClass("error").addClass("hide"), o.find("." + i.options["class"]).removeClass("show").addClass("valid").text(i.errors)
    }, t.prototype.reset = function (t, i) {
        var o = e(this).find("." + i.options["class"]);
        o.hasClass("error") && o.removeClass("error").addClass("hide"), e(this).find("." + i.options["class"]).removeClass("show")
    }
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.Input = function (i) {
        this._core = i, this._handlers = {
            "mfInput.focus": this.focus,
            "mfInput.blur": this.blur,
            "mfInput.type": this.type,
            "mfInput.delete": this["delete"],
            "mfInput.fill": this.fill,
            "mfInput.empty": this.empty,
            "mfInput.idle": this.idle,
            "mfInput.reset": this.reset,
            click: function (e) {
                return e.preventDefault(), !1
            }
        }, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    t.Defaults = {
        input: {
            applyto: 'input[type="text"], input[type="date"], textarea',
            "class": "mfInput"
        }
    }, t.prototype.initialize = function () {
        this._core.$element.trigger("mfInput.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfInput.initialized")
    }, t.prototype.create = function () {
        this._core.$element.find(this._core.options.input.applyto).parent().addClass(this._core.options.input["class"])
    }, t.prototype.watch = function () {
        this._core.$element.find(this._core.options.input.applyto).on("focus", function () {
            e(this).parent().trigger("mfInput.focus")
        }).on("blur", function () {
            e(this).parent().trigger("mfInput.blur"), "" === e(this).val() && e(this).parent().trigger("mfInput.void")
        }).on("keydown", this, function (t) {
            t.data.ignore(t) || ((8 === t.keyCode || 46 === t.keyCode) && e(this).parent().trigger("mfInput.delete"), (32 === t.keyCode || t.keyCode > 46) && e(this).parent().trigger("mfInput.type"))
        }).on("keyup input propertychange", this, function (t) {
            var i = e(this);
            t.data.ignore(t) || ("" === i.val() && i.parent().trigger("mfInput.empty"), 8 === t.keyCode || 46 === t.keyCode ? (self.timer && clearTimeout(self.timer), self.timer = setTimeout(function () {
                i.parent().trigger("mfInput.idle")
            }, 1e3)) : (i.parent().trigger("mfInput.fill"), i.parent().trigger("mfInput.type"), self.timer && clearTimeout(self.timer), self.timer = setTimeout(function () {
                i.parent().trigger("mfInput.idle")
            }, 1e3)))
        }).on("keypress", this, function (t) {
            if (!t.data.ignore(t.keyCode)) {
                var i = e(this);
                self.timer && clearTimeout(self.timer), self.timer = setTimeout(function () {
                    i.parent().trigger("mfInput.idle")
                }, 1e3)
            }
        }).parent().on(this._handlers), this._core.$element.on("mf.reset", this, function (t) {
            e(this).find("." + t.data._core.options.input["class"]).each(function () {
                e(this).trigger("mfInput.reset")
            })
        })
    }, t.prototype.focus = function () {
        e(this).addClass("focused")
    }, t.prototype.blur = function () {
        e(this).removeClass("focused")
    }, t.prototype.type = function () {
        e(this).removeClass("deleting"), e(this).addClass("typing")
    }, t.prototype["delete"] = function () {
        e(this).removeClass("typing"), e(this).addClass("deleting")
    }, t.prototype.fill = function () {
        e(this).addClass("filled")
    }, t.prototype.empty = function () {
        e(this).removeClass("filled")
    }, t.prototype.idle = function () {
        e(this).removeClass("typing"), e(this).removeClass("deleting")
    }, t.prototype.reset = function () {
        e(this).removeClass("focused"), e(this).removeClass("deleting"), e(this).removeClass("filled"), e(this).removeClass("typing"), e(this).removeClass("error")
    }, t.prototype.ignore = function (e) {
        return 144 === e.keyCode || 20 === e.keyCode || 17 === e.keyCode || 37 === e.keyCode || 38 === e.keyCode || 39 === e.keyCode || 40 === e.keyCode || 112 === e.keyCode || 113 === e.keyCode || 114 === e.keyCode || 115 === e.keyCode || 116 === e.keyCode || 117 === e.keyCode || 118 === e.keyCode || 119 === e.keyCode || 120 === e.keyCode || 121 === e.keyCode || 122 === e.keyCode || 123 === e.keyCode || 9 === e.keyCode || e.ctrlKey ? !0 : !1
    }
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.Select = function (i) {
        this._core = i, this._handlers = {
            "mfSelect.close": this.close,
            "mfSelect.open": this.open,
            "mfSelect.select": this.select,
            click: function (e) {
                e.preventDefault(), e.stopPropagation()
            }
        }, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    t.Defaults = {select: {applyTo: "select", "class": "mfSelect"}}, t.prototype.initialize = function () {
        this._core.$element.trigger("mfSelect.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfSelect.initialized")
    }, t.prototype.create = function () {
        this._core.$element.find(this._core.options.select.applyTo).each(function () {
            var t = e(this);
            t.css({
                position: "absolute",
                left: "50%",
                width: "0",
                height: "0",
                overflow: "hidden",
                opacity: "0"
            }).parent().append(e("<div/>", {
                "class": "value",
                text: t.find("option:selected").text()
            })).append(e("<ul/>", {"class": "dropdown"})).end().find("option").each(function (t) {
                if (0 != t) {
                    var i = e(this);
                    i.parent().parent().find(".dropdown").append(e("<li/>", {
                        "class": "option",
                        text: i.text()
                    }).addClass(i.is(":selected") ? "selected" : ""))
                }
            })
        }).parent().addClass(this._core.options.select["class"])
    }, t.prototype.watch = function () {
        var t = this;
        this._core.$element.find(t._core.options.select.applyTo).on("focus", this.focus).on("blur", function () {
            e(this).parent().trigger("mfSelect.close").removeClass("focus")
        }).on("keydown", function (t) {
            38 == t.keyCode && e(this).val(e(this).find("option").eq(e(this).find("option:selected").index() > 0 ? e(this).find("option:selected").index() - 1 : 0).text()).trigger("change"), 40 == t.keyCode && e(this).val(e(this).find("option").eq(e(this).find("option:selected").index() < e(this).find("option").length - 1 ? e(this).find("option:selected").index() + 1 : e(this).find("option").length - 1).text()).trigger("change"), 13 == t.keyCode && e(this).parent().trigger(e(this).parent().hasClass("show") ? "mfSelect.close" : "mfSelect.open"), (32 == t.keyCode || 37 == t.keyCode || 38 == t.keyCode || 39 == t.keyCode || 40 == t.keyCode || 13 == t.keyCode) && t.preventDefault()
        }).on("change", function () {
            e(this).parent().trigger("mfSelect.open").find(".value").text(e(this).val());
            var t = e(this).find("option:selected").index(), i = e(this).parent().find(".option").removeClass("selected");
            t > 0 && i.eq(t - 1).addClass("selected")
        }).parent().on(this._handlers).find(".value").on("click", function () {
            var i = e(this), o = i.parent().find("select"), s = o.find("option").eq(0).text();
            if (i.text(s), o.trigger("focus").off("focus", t.focus), !e(this).parent().hasClass("show")) {
                o.on("focus", t.focus);
                var n = e(this).parent().find(".option.selected");
                n.length && i.text(n.text())
            }
        }).parent().find(".option").on("click", function () {
            e(this).parent().find(".option").removeClass("selected"), e(this).addClass("selected"), e(this).parent().parent().find("select").focus().on("focus", t.focus), e(this).parent().parent().trigger("mfSelect.select", {
                options: t._core.options.select,
                value: e(this).text()
            })
        }).parents("body").on("click", function (i) {
            var o = t._core.$element.find("." + t._core.options.select["class"]);
            o.length && (o.is(i.target) || 0 !== o.has(i.target).length || o.find("select").each(function () {
                var t = e(this).parent().find(".option.selected");
                t.length && e(this).parent().find(".value").text(t.text())
            }).on("focus", t.focus))
        }), this._core.$element.on("mf.reset", function () {
            e(this).find(t._core.options.select.applyTo).each(function () {
                e(this).parent().find(".value").text(e(this).prop("selectedIndex", 0).val()), e(this).parent().find(".option").removeClass("selected")
            })
        })
    }, t.prototype.focus = function () {
        e(this).parent().trigger("mfSelect.open").addClass("focus")
    }, t.prototype.close = function () {
        navigator.userAgent.match(/(iPod|iPhone|iPad)/) || e(this).hasClass("show") && e(this).removeClass("show")
    }, t.prototype.open = function () {
        navigator.userAgent.match(/(iPod|iPhone|iPad)/) || e(this).hasClass("show") || e(this).addClass("show")
    }, t.prototype.select = function (t, i) {
        e(this).find(i.options.applyTo).val(i.value).trigger("change"), e(this).trigger("mfSelect.close")
    }
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.DatePicker = function (i) {
        this._core = i, this._handlers = {
            "mfDatePicker.close": this.close,
            "mfDatePicker.open": this.open,
            "mfDatePicker.next": this.next,
            "mfDatePicker.prev": this.prev,
            "mfDatePicker.update": this.update,
            "mfDatePicker.refresh": this.refresh,
            "mfDatePicker.pick": this.pick
        }, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    t.Defaults = {
        datepicker: {
            applyTo: 'input[type="date"]',
            "class": "mfDatePicker",
            days: ["Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"],
            months: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
            format: "MM-DD-YYYY",
            prevMonth: "",
            nextMonth: ""
        }
    }, t.prototype.initialize = function () {
        this._core.$element.trigger("mfDatePicker.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfDatePicker.initialized")
    }, t.prototype.create = function () {
        var t = this;
        t._core.$element.find(t._core.options.datepicker.applyTo).each(function () {
            e(this).attr({
                type: navigator.userAgent.match(/(iPod|iPhone|iPad)/) ? "date" : "text",
                "data-type": "date"
            }).after(e("<div/>", {"class": t._core.options.datepicker["class"]}).data("date", new Date))
        }).parent().find("." + t._core.options.datepicker["class"]).each(function () {
            e.proxy(t.update, this, {}, t._core.options.datepicker).call(), e.proxy(t.refresh, this, {}, t._core.options.datepicker).call()
        })
    }, t.prototype.watch = function () {
        var t = this;
        t._core.$element.find("." + t._core.options.datepicker["class"]).on("click", "." + t._core.options.datepicker["class"] + "_next", function () {
            var i = e(this).parents("." + t._core.options.datepicker["class"]);
            i.trigger("mfDatePicker.next"), i.trigger("mfDatePicker.update", t._core.options.datepicker), i.trigger("mfDatePicker.refresh", t._core.options.datepicker)
        }).on("click", "." + t._core.options.datepicker["class"] + "_prev", function () {
            var i = e(this).parents("." + t._core.options.datepicker["class"]);
            i.trigger("mfDatePicker.prev"), i.trigger("mfDatePicker.update", t._core.options.datepicker), i.trigger("mfDatePicker.refresh", t._core.options.datepicker)
        }).on("click", ".dp-day", function () {
            var i = e(this).parents("." + t._core.options.datepicker["class"]);
            i.trigger("mfDatePicker.pick", {
                opt: t._core.options.datepicker,
                day: e(this)
            }), i.parent().find("input").on("blur", t.blur).trigger("blur").trigger("keyup")
        }).on("click", function () {
        }).on(this._handlers).parent().on("click", function (e) {
            return e.preventDefault(), !1
        }).find("input").on("focus", function () {
            e(this).parent().find("." + t._core.options.datepicker["class"]).trigger("mfDatePicker.open")
        }).on("blur", this.blur).on("keydown", function (i) {
            (9 == i.keyCode || i.shiftKey && 9 == i.keyCode) && e(this).on("blur", t.blur)
        }).parents("body").on("mousedown", function (e) {
            var i = t._core.$element.find("." + t._core.options.datepicker["class"]).parent();
            i.length && (i.is(e.target) || 0 !== i.has(e.target).length ? i.find("input").off("blur", t.blur) : i.find("input").on("blur", t.blur).trigger("blur"))
        }), t._core.$element.on("mf.reset", function () {
            e(this).find("." + t._core.options.datepicker["class"]).each(function () {
                e(this).trigger("mfDatePicker.close")
            })
        })
    }, t.prototype.blur = function () {
        e(this).parent().find(".mfDatePicker").trigger("mfDatePicker.close")
    }, t.prototype.close = function () {
        navigator.userAgent.match(/(iPod|iPhone|iPad)/) || e(this).hasClass("open") && e(this).removeClass("open")
    }, t.prototype.open = function () {
        navigator.userAgent.match(/(iPod|iPhone|iPad)/) || e(this).hasClass("open") || e(this).addClass("open")
    }, t.prototype.next = function () {
        var t = e(this), i = t.data("date");
        i = 11 == i.getMonth() ? new Date(i.getFullYear() + 1, 0, 1) : new Date(i.getFullYear(), i.getMonth() + 1, 1), t.data("date", i)
    }, t.prototype.prev = function () {
        var t = e(this), i = t.data("date");
        i = 0 == i.getMonth() ? new Date(i.getFullYear() - 1, 11, 1) : new Date(i.getFullYear(), i.getMonth() - 1, 1), t.data("date", i)
    }, t.prototype.pick = function (t, i) {
        var o = e(this);
        o.data("pickedDate", i.day.addClass("dp-selected").data("date")), o.find(".dp-day").not(i.day).removeClass("dp-selected"), o.parent().find("input").val((o.data("pickedDate").getMonth() + 1 < 10 ? "0" + (o.data("pickedDate").getMonth() + 1) : o.data("pickedDate").getMonth() + 1) + "/" + (o.data("pickedDate").getDate() < 10 ? "0" + o.data("pickedDate").getDate() : o.data("pickedDate").getDate()) + "/" + o.data("pickedDate").getFullYear())
    }, t.prototype.update = function (t, i) {
        var o = e(this), s = e("<div/>", {"class": i["class"] + "_panel"});
        s.append(e("<a/>", {
            "class": i["class"] + "_prev",
            text: i.prevMonth
        })), s.append(e("<a/>", {
            "class": i["class"] + "_next",
            text: i.nextMonth
        })), s.append(e("<div/>", {
            "class": i["class"] + "_title",
            text: i.months[o.data("date").getMonth()] + " " + o.data("date").getFullYear()
        }));
        var n = o.find("." + i["class"] + "_panel");
        n.length ? n.replaceWith(s) : s.appendTo(o)
    }, t.prototype.refresh = function (t, i) {
        for (var o = e(this), s = e("<table/>"), n = e("<tr/>"), a = 0; a < i.days.length; a++)n.append(e("<th/>", {
            "class": "dp-weekday",
            text: i.days[a]
        }));
        s.append(n);
        for (var r = o.data("date"), l = o.data("pickedDate"), c = new Date(r.getFullYear(), r.getMonth() + 1, 0).getDate(), p = new Date(r.getFullYear(), r.getMonth(), 0).getDate(), d = new Date(r.getFullYear(), r.getMonth(), 1).getDay(), f = 1, a = 0; 7 > a; a++) {
            n = e("<tr/>");
            for (var h = 0; 7 > h; h++) {
                var u, m = 7 * a + h + 1, g = e("<td/>", {"class": "dp-day"}), y = new Date;
                if (y.setHours(0), y.setMinutes(0), y.setSeconds(0), y.setMilliseconds(0), 0 == h && m > c + d)break;
                1 > m - d ? (g.text(p + (m - d)).addClass("dp-offset"), u = new Date(r.getFullYear(), r.getMonth() - 1, p + (m - d))) : c + d >= m ? (g.text(m - d), u = new Date(r.getFullYear(), r.getMonth(), m - d)) : (g.text(f).addClass("dp-offset"), u = new Date(r.getFullYear(), r.getMonth() + 1, f++)), u.valueOf() == y.valueOf() && g.addClass("dp-today"), l && u.valueOf() == l.valueOf() && g.addClass("dp-selected"), n.append(g.data("date", u))
            }
            "" != n.html() && s.append(n)
        }
        var v = o.find("table");
        v.length ? v.replaceWith(s) : s.appendTo(o)
    }
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.Icon = function (i) {
        this._core = i, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    this._handlers = {"mfIcon.change": this.change}, t.Defaults = {
        icon: {
            applyTo: "[data-add-icon]",
            "class": "mfIcon",
            states: {
                ".mfInput": {
                    "mfIcon.default": ["mfInput.blur", "mfInput.idle", "mfInput.reset"],
                    "mfIcon.state-1": ["mfInput.type"],
                    "mfIcon.state-2": ["mfInput.delete"]
                }
            }
        }
    }, t.prototype.initialize = function () {
        this._core.$element.trigger("mfIcon.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfIcon.initialized")
    }, t.prototype.create = function () {
        var t = this;
        t._core.$element.find(t._core.options.icon.applyTo).each(function () {
            var i = e(this);
            i.append(e("<span/>", {"class": t._core.options.icon["class"]}).append(e("<span/>")))
        })
    }, t.prototype.watch = function () {
        var t = this;
        t._core.$element.find("." + t._core.options.icon["class"]).on(t._handlers);
        for (var i in t._core.options.icon.states) {
            var o = t._core.$element.find(i);
            for (var s in t._core.options.icon.states[i])for (var n in t._core.options.icon.states[i][s])o.on(t._core.options.icon.states[i][s][n], {state: s}, function (i) {
                e(this).find("." + t._core.options.icon["class"]).attr("class", i.data.state.replace(".", " "))
            })
        }
    }
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.Placeholder = function (i) {
        this._core = i, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    this._handlers = {"mfIcon.change": this.change}, t.Defaults = {
        placeholder: {
            applyTo: "[data-add-placeholder]",
            "class": "mfPlaceHolder",
            states: {
                ".mfInput": {
                    "mfPlaceHolder.default": ["mfInput.void", "mfInput.reset"],
                    "mfPlaceHolder.state-1": ["mfInput.fill", "mfInput.focus"]
                }
            }
        }
    }, t.prototype.initialize = function () {
        this._core.$element.trigger("mfPlaceHolder.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfPlaceHolder.initialized")
    }, t.prototype.create = function () {
        var t = this;
        t._core.$element.find(t._core.options.placeholder.applyTo).each(function () {
            var i = e(this);
            i.append(e("<span/>", {
                "class": t._core.options.placeholder["class"],
                text: i.find("[placeholder]").attr("placeholder") ? i.find("[placeholder]").attr("placeholder") : i.find("[data-placeholder]").attr("data-placeholder")
            })).find("[placeholder]").removeAttr("placeholder").removeAttr("data-placeholder")
        })
    }, t.prototype.watch = function () {
        var t = this;
        t._core.$element.find("." + t._core.options.placeholder["class"]).on("click", function () {
            e(this).parent().find("input, textarea").trigger("focus")
        }).on(t._handlers);
        for (var i in t._core.options.icon.states) {
            var o = t._core.$element.find(i);
            for (var s in t._core.options.placeholder.states[i])for (var n in t._core.options.placeholder.states[i][s])o.on(t._core.options.placeholder.states[i][s][n], {state: s}, function (i) {
                e(this).find("." + t._core.options.placeholder["class"]).attr("class", i.data.state.replace(".", " "))
            })
        }
    }
}(window.jQuery, window, document), function (e) {
    var t = e.fn.rdMailForm.Constructor.Plugins.Progress = function (i) {
        this._core = i, this._core.options = e.extend(!0, {}, t.Defaults, this._core.options), this.initialize()
    };
    t.Defaults = {progress: {applyTo: ".mfInfo", "class": "mfProgress"}}, t.prototype.initialize = function () {
        this._core.$element.trigger("mfProgress.initialize"), this.create(), this.watch(), this._core.$element.trigger("mfProgress.initialized")
    }, t.prototype.create = function () {
        var t = this;
        t._core.$element.find(t._core.options.progress.applyTo).each(function () {
            var i = e(this);
            i.addClass(t._core.options.progress["class"]).wrapInner(e("<span/>", {"class": "cnt"})).append(e("<span/>", {"class": "loader"})).append(e("<span/>", {"class": "msg"}))
        })
    }, t.prototype.watch = function () {
        var t = this;
        t._core.$element.on("mf.process", function () {
            e(this).find("." + t._core.options.progress["class"]).removeClass("hide").addClass("sending").find(".msg").text("Loading...")
        }).on("mf.fail", function (i, o) {
            e(this).find("." + t._core.options.progress["class"]).removeClass("sending").addClass("fail").find(".msg").text(o.message), setTimeout(e.proxy(function () {
                e(this).find("." + t._core.options.progress["class"]).removeClass("fail").addClass("hide").find(".msg")
            }, this), 3e3)
        }).on("mf.success", function (i, o) {
            e(this).find("." + t._core.options.progress["class"]).removeClass("sending").addClass("success").find(".msg").text(o.message), setTimeout(e.proxy(function () {
                e(this).find("." + t._core.options.progress["class"]).removeClass("success").addClass("hide").find(".msg")
            }, this), 1500)
        }).on("mf.reset", function () {
            e(this).find("." + t._core.options.progress["class"]).removeClass("sending").removeClass("fail").removeClass("success").find(".msg")
        })
    }
}(window.jQuery, window, document);